$(function () {
  var client = ZAFClient.init();
  client.invoke("resize", { width: "100%", height: "200px" });
  showGetDocsButton();

  $("#get-btn").click(function (event) {
    event.preventDefault();
    showDealArticles(client);
  });

  client.get("deal.name").then(function (data) {
    var deal_name = data["deal.name"];
    dealCardName(deal_name);
  });
});

function dealCardName(deal_name) {
  var data = { name: deal_name };
  var source = $("#deal-name-template").html();
  var template = Handlebars.compile(source);
  var html = template(data);
  $("#deal-name").html(html);
}

function showGetDocsButton() {
  var source = $("#get-docs-btn-template").html();
  var template = Handlebars.compile(source);
  $("#content").html(template());
}

function showDealArticles(client) {
  var url = "https://support.zendesk.com/api/v2/help_center/articles/search.json?section=360006252673";
  var request = new XMLHttpRequest();
  request.onreadystatechange = handleResponse;
  request.open("GET", url);
  request.send();

  function handleResponse() {
    if (request.readyState === XMLHttpRequest.DONE) {
      if (request.status === 200) {
        response = JSON.parse(request.responseText);

        let articles = [];
        for (var article of response.results) {
          articles.push({ title: article.title, url: article.html_url });
        }
        showArticles(articles);
      } else {
        console.log("There was a problem with the request.");
      }
    }
  }

  function showArticles(articles) {
    var article_data = { articles: articles };
    var source = $("#articles-template").html();
    var template = Handlebars.compile(source);
    var html = template(article_data);
    $("#content").html(html);
  }
}
